
#include <cstdio>
#include <vector>
using namespace std;

const int MAXA = 26;
const int MAXL = 16;
const int MAXN = 128;

int N, M;
char name[MAXN];
char word[MAXL];
int dp[MAXL][MAXN];
vector <int> edge[MAXN][MAXA];

// Assume the word won't be empty!

void read() {
	scanf("%d %d", &N, &M);
	scanf("%s", name);
	for (int i = 0; i < M; ++i) {
		int u, v;
		scanf("%d %d", &u, &v);
		edge[u - 1][name[v - 1] - 'A'].push_back(v - 1);
		if (u != v)
			edge[v - 1][name[u - 1] - 'A'].push_back(u - 1);
	}
	scanf("%s", word);
}

int solve() {
	int L = strlen(word);
	for (int i = 0; i < N; ++i)
		if (word[0] == name[i])
			dp[1][i] = 1;
	for (int i = 1; i < L; ++i)
		for (int j = 0; j < N; ++j)
			if (dp[i][j] > 0) {
				int ch = word[i] - 'A';
				vector <int> &go = edge[j][ch];
				for (typeof(go.begin()) it = go.begin(); it != go.end(); ++it)
					dp[i + 1][*it] += dp[i][j];
			}
	int res = 0;
	for (int i = 0; i < N; ++i)
		res += dp[L][i];
	return res;
}

int main() {
	read();
	printf("%d\n", solve());
	return 0;
}
