#include <cstdio>
#include <cstring>
#include <queue>
#include <utility>

#define pii pair<int, int>

using namespace std;

struct edge {
	int to, next;
	edge() { }
	edge(int _to, int _next) : to(_to), next(_next) { }
} e[16384];
int en;
struct vertex {
	int next;
	char c;
	bool used[16];
	int ways[16];
} v[128];
int n;

void add_edge(int from, int to) {
	e[en] = edge(to, v[from].next);
	v[from].next = en;
	++en;
}

char resp[128];
char str[16];
void read() {
	for(int i = 0; i < 128; ++i) v[i].next = -1;
	int m, a, b;
	scanf("%d%d", &n, &m);
	scanf("%s", resp);
	for(int i = 0; i < n; ++i)
		v[i].c = resp[i];
	for(int i = 0; i < m; ++i) {
		scanf("%d%d", &a, &b); --a; --b;
		add_edge(a, b);
		if(a != b)
			add_edge(b, a);
	}
	scanf("%s", str);
}

queue<pii> bfsq;
void bfs(int start) {
	for(int i = 0; i < 128; ++i)
		for(int j = 0; j < 16; ++j) {
			v[i].used[j] = 0;
			v[i].ways[j] = 0;
		}
	bfsq = queue<pii>();
	bfsq.push(pii(start, 1));
	v[start].ways[1] = 1;
	pii cur;
	int cv, cl;
	while(!bfsq.empty()) {
		cur = bfsq.front(); bfsq.pop();
		//printf("visit %d %d %d\n", cur.first+1, cur.second, v[cur.first].ways[cur.second]);
		cl = cur.second;
		for(int i = v[cur.first].next; i != -1; i = e[i].next) {
			cv = e[i].to;
			if(v[cv].c == str[cl]) {
				v[cv].ways[cl+1] += v[cur.first].ways[cl];
				if(!v[cv].used[cl+1]) {
					v[cv].used[cl+1] = 1;
					bfsq.push(pii(cv, cl+1));
				}
			}
		}
	}
}

int main() {
	read();
	int res = 0, strl = strlen(str);
	for(int i = 0; i < n; ++i) {
		if(v[i].c == str[0]) {
			//printf("start bfs from %d\n", i+1);
			bfs(i);
			for(int j = 0; j < n; ++j) {
				res += v[j].ways[strl];
				//printf("%d ways to get to %d\n", v[j].ways[strl], j+1);
			}
		}
	}
	printf("%d\n", res);
	return 0;
}
