#include<cstdio>
#include<cstdlib>
#include<vector>

struct point
{
	int x, y;
};

struct triangle
{
	point A, B, C;
};

inline int cross(int a1, int b1, int a2, int b2)
{
	return a1*b2 - b1*a2;
}

int in_tr(triangle a, point b)
{
	if ((cross(b.x - a.A.x, b.y - a.A.y, a.B.x - a.A.x, a.B.y - a.A.y)*cross(b.x - a.B.x, b.y - a.B.y, a.C.x - a.B.x, a.C.y - a.B.y) >0) &&
	(cross(b.x - a.A.x, b.y - a.A.y, a.B.x - a.A.x, a.B.y - a.A.y)*cross(b.x - a.C.x, b.y - a.C.y, a.A.x - a.C.x, a.A.y - a.C.y) >0))
	{
		return 1;
	}

	return 0;

}
int test(triangle a, triangle b)
{
	if (in_tr(a, b.A) && in_tr(a, b.B) && in_tr(a, b.C))
		return 1;

	if (in_tr(b, a.A) && in_tr(b, a.B) && in_tr(b, a.C))
		return -1;

	return 0;
}

std::vector<int> g[2000];
int current = 0, m = 0;

void DFS(int i)
{
	current++;
	if (current > m)
		m = current;

	for (int j = 0; j < g[i].size(); j++)
	{
		DFS(g[i][j]);
	}

	current--;
}

int main()
{
	int n;
	scanf("%d", &n);

	triangle tr[n];
	int noparent[n];

	for (int i = 0; i < n; i++)
	{
		noparent[i] = 1;
	}

	for (int i = 0; i < n; i++)
	{
		scanf("%d %d %d %d %d %d", &tr[i].A.x, &tr[i].A.y, &tr[i].B.x, &tr[i].B.y, &tr[i].C.x, &tr[i].C.y);

		for (int j = 0; j < i; j++)
		{
			switch (test(tr[i], tr[j]))
			{
				case 1:
					g[i].push_back(j);
					noparent[j] = 0;
					break;
				case -1:
					g[j].push_back(i);
					noparent[i] = 0;
					break;
				default:
					break;
			}
		}
	}

	/*for (int i = 0; i < n; i++)
	{
		printf("za vrah %d:", i);

		for (int j = 0; j < g[i].size(); j++)
		{
			printf("%d ", g[i][j]);
		}

		printf("\n");
	}*/

	for (int i = 0; i < n; i++)
	{
		if ((g[i].size() != 0) && (noparent[i]))
			DFS(i);
	}

	printf("%d\n", m);

	return 0;
}
