#include <iostream>
#include <sstream>
#include <cstdio>
using namespace std;

#define MAXN 801

struct bignum {
 int dig[64], len; 
 bignum() { memset(dig, 0, sizeof(dig)); len = 1; }
 bignum(int num) {
  memset(dig, 0, sizeof(dig));
  
  len = 0;
  while (num)
  {
   dig[len++] = num % 10;
   num /= 10;
  }            
 }
 bignum operator+=(const bignum &o)
 {
  len >?= o.len;
  int carry = 0;
  for (int i = 0; i < len; i++)
  {
   int sum = dig[i] + o.dig[i] + carry;
   carry = sum / 10;
   dig[i] = sum % 10;
  }
  if (carry) dig[len++] = carry;
  return *this;
 }
 void print() { 
  for (int i = len - 1; i >= 0; i--)
   printf("%d", dig[i]);
  printf("\n");
 }
};

int N, K;

bignum DP[2][MAXN];

int main()
{
 cin >> N >> K;
 
 int cur = 0;
 
 for (int i = 1; i <= K; i++) 
 {
  cur ^= 1;
  for (int j = 0; j <= N; j++) 
   DP[cur][j] = bignum(0);
  DP[cur][i] = bignum(1);
  for (int j = i + 1; j <= N; j++)
  {
   DP[cur][j] += DP[cur][j - i];
   DP[cur][j] += DP[cur ^ 1][j - 1];
  }
 }
 
 DP[cur][N].print();
 
 return 0;
}
